// Main.as
package {
  import flash.display.Sprite;
  import flash.events.*;
  import flash.text.TextFormat;
  import flash.text.TextField;
  import flash.net.XMLSocket;
  import flash.utils.*;
  import flash.system.Security;
  import flash.errors.IOError;

[SWF(width="300", height="200", backgroundColor="0xFFFFFF")]

  public class Main extends Sprite {
    private var socket:XMLSocket;
    private var timer:Timer;
    private var te1:Te1;
    private var te2:Te2;
    private var rect1:Rect1;
    private var text_field:TextField;
    private var ite1:int;
    private var ite2:int;
    private var state:int;
    private var list:Array = [[0, 1, 2],[2, 0, 1],[1, 2, 0]];

    public function Main():void {
      state = 0;

      text_field = new TextField();
      var format:TextFormat = new TextFormat();
      format.size = 20;
      text_field.defaultTextFormat = format;

      text_field.x = 175;
      text_field.y = 25;
      text_field.width = 100;
      text_field.height = 50;

      addChild(text_field);

      te1 = new Te1();
      te1.x = 50;
      te1.y = 100;
      addChild(te1);

      te2 = new Te2();
      te2.x = 50;
      te2.y = 0;
      addChild(te2);

      rect1 = new Rect1(this, 175, 125, 100, 50);

      rect1.setButtonText("log in");

      addChild(rect1);

      Security.loadPolicyFile("xmlsocket://127.0.0.1:843");

      socket = new XMLSocket();

      socket.addEventListener(Event.CLOSE, closeHandler);
      socket.addEventListener(Event.CONNECT, connectHandler);
      socket.addEventListener(DataEvent.DATA, dataHandler);
      socket.addEventListener(IOErrorEvent.IO_ERROR, ioErrorHandler);
      socket.addEventListener(ProgressEvent.PROGRESS, progressHandler);
      socket.addEventListener(SecurityErrorEvent.SECURITY_ERROR, securityErrorHandler);

      timer = new Timer(3000, 0);
      timer.addEventListener(TimerEvent.TIMER, onTick);
      timer.start();  
    }

    public function push():void {
      var sendText:String;

      if(state == 0){
        socket.connect("127.0.0.1", 40002);
      }

      else if(state == 1) {
        state = 2;  

        text_field.text = "waiting...";

        te2.set_te2(3);

        wait(20);

        if(te1.get_te1() == 0) {
          ite1 = 0;
          sendText = "g";
        }
        else if(te1.get_te1() == 1) {
          ite1 = 1;
          sendText = "c";
        } 
        else if (te1.get_te1() == 2) {
          ite1 = 2;
          sendText = "p";
        }

        try{
          socket.send(sendText);
        }
        catch(e:IOError) {
          text_field.text = "error!";
        }
      }
    }

    public function wait(count:uint ):void{
      var start:uint = getTimer();
      while(getTimer() - start < count){}
    }

    private function closeHandler(event:Event):void {
      trace("closeHandler: " + event);
    }

    private function connectHandler(event:Event):void {
      text_field.text = "log in ok!";
      state = 1;
      rect1.setButtonText("pong");
      trace("connectHandler: " + event);
    }

    private function dataHandler(event:DataEvent):void {
      trace("dataHandler: " + event);

      if(state == 2) {
        var o:oto = new oto();
        o.play();
        wait(1000);
        var str:String = event.data;

        if(str.charAt(0) == 'g') {
          ite2 = 0;
          te2.set_te2(0);
        }
        else if(str.charAt(0) == 'c') {
          ite2 = 1;
          te2.set_te2(1);
        }
        else if(str.charAt(0) == 'p') {
          ite2 = 2;
          te2.set_te2(2);
        }
        else{
          te2.set_te2(3);
        }

        if(list[ite1][ite2] == 0) {
          text_field.text = " draw.";  
        }
        else if (list[ite1][ite2] == 1) {
          text_field.text = " you win!";
        }
        else if (list[ite1][ite2] == 2) {
          text_field.text = " you lose.";
        }

        state = 1;
      }
    }

    private function ioErrorHandler(event:IOErrorEvent):void {
      text_field.text = "log in error.";

      trace("ioErrorHandler: " + event);
    }

    private function progressHandler(event:ProgressEvent):void {
      trace("progressHandler loaded:" + event.bytesLoaded + " total: " + event.bytesTotal);
    }

    private function securityErrorHandler(event:SecurityErrorEvent):void {
      trace("securityErrorHandler: " + event);
    }

    private function onTick(evt:TimerEvent):void {
      var sendText:String;

      if(state != 0) {
        sendText = "t";
        socket.send(sendText);
      }
    }
  }
}
