/*
*   WPQ[pT[o[vO
*   gcc serv.c -lpthread
*/

#include <stdio.h>
#include <pthread.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>

#define PORT 40002
#define BUFFER_SIZE 256

typedef struct{
  int *sock;
  int num;
  int *te;
  int *opposite_te;
}player;

static pthread_mutex_t mutex;

static void* thread(void* pParam);

int main(){
  int result;
  int te[2];
  player p[2];

  unsigned short port = PORT;
  int srcSocket;
  int dstSocket[2];

  struct sockaddr_in srcAddr;
  struct sockaddr_in dstAddr;
  int dstAddrSize = sizeof(dstAddr);

  pthread_t tid[2];

  te[0] = 0;
  te[1] = 0;

  dstSocket[0] = -1;
  dstSocket[1] = -1;

  memset(&srcAddr, 0, sizeof(srcAddr));
  srcAddr.sin_port = htons(port);
  srcAddr.sin_family = AF_INET;
  srcAddr.sin_addr.s_addr = htonl(INADDR_ANY);

  /* socket */
  srcSocket = socket(AF_INET, SOCK_STREAM, 0);

  if(srcSocket == -1){
    printf("socket error\n");
    return -1;
  }

  /* bind */
  result = bind(srcSocket, (struct sockaddr *) &srcAddr, sizeof(srcAddr));

  if(result == -1){
    printf("bind error\n");
    return -1;
  }

  /* listen */
  result = listen(srcSocket, 5);

  if(result == -1){
    printf("listen error\n");
    return -1;
  }

  pthread_mutex_init(&mutex, NULL);

  while(1){
    int i;
    int dstSock;

    /* accept */
    dstSock = accept(srcSocket, (struct sockaddr *)&dstAddr, &dstAddrSize);

    if(dstSock == -1){
      continue;
    }

    for(i = 0; i < 3; i++){
      if(i == 2){
        printf("login is denied\n");
        close(dstSock);
        break;
      }
      else if(dstSocket[i] == -1){
        printf("player%d:login\n", (i + 1));
        dstSocket[i] = dstSock;
        p[i].sock = &dstSocket[i];
        p[i].num = (i + 1);
        p[i].te = &te[i];
        p[i].opposite_te = &te[(i + 1) % 2];
        pthread_create(&tid[i], NULL, thread, &p[i]);
        break;
      }
    }
  }

  pthread_mutex_destroy(&mutex);
}

/* thread */
void* thread(void* pParam)
{
  int numrcv;
  char buffer[BUFFER_SIZE + 10];
  player *p = (player *)pParam;
  int *dstSocket = p->sock;
  int num = p->num;
  int *te = p->te;
  int *opposite_te = p->opposite_te;
  while(1){
    numrcv = recv(*dstSocket, buffer, BUFFER_SIZE, 0);
    if(numrcv == 0 || numrcv == -1) {
      goto close;
    }
    buffer[numrcv] = '\0';
    printf("received%d: %s\n", num, buffer);

    if(buffer[0] == 'g'){
      *te = 1;
    }
    else if(buffer[0] == 'c'){
      *te = 2;
    }
    else if(buffer[0] == 'p'){
      *te = 3;
    }
    else{
      continue;
    }

    while(1){
      numrcv = recv(*dstSocket, buffer, BUFFER_SIZE, 0);
      if(numrcv == 0 || numrcv == -1) {
        goto close;
      }
      buffer[numrcv] = '\0';
      printf("received%d: %s\n", num, buffer);

      if(*opposite_te != 0){
        char buf[10];

        pthread_mutex_lock(&mutex);

        if(*opposite_te == 1){
          buf[0] = 'g';
          buf[1] = '\0';
          send(*dstSocket, buf, 2, 0);
        }
        else if(*opposite_te == 2){
          buf[0] = 'c';
          buf[1] = '\0';
          send(*dstSocket, buf, 2, 0);
        }
        else if(*opposite_te == 3){
          buf[0] = 'p';
          buf[1] = '\0';
          send(*dstSocket, buf, 2, 0);
        }

        printf("send%d: %s\n", num, buf);

        *opposite_te = 0;

        pthread_mutex_unlock(&mutex);

        break;
      }
    }
  }

close:
  *te = 0;
  *dstSocket = -1;
  printf("player%d:close\n", num);
  return;
}
